<?php

class awnav {

   var $ulClasses = array();
   var $currentPath;
   var $currentCat;
   var $maxLev = 999;
   var $currentCatId;
   var $ignoreOffline = true;
   var $fullTree = false; // ganzen Menübaum anzeigen, unabhängig von der aktuell gewählten Kategorie
   var $metaField = '';
   var $metaValue = '';

   public function __construct() {
      $this->currentCat = rex_category::getCurrent();
      $this->currentCatId = $this->currentCat->getId();
      $this->currentPath = explode('|', trim($this->currentCat->getPath(), '|') . '|' . $this->currentCatId);
   }

   public function getNavigation() {
      $out = '';
      $cssclass = (isset($this->ulClasses[0])) ? ' '.$this->ulClasses[0] : '';
      $categories = rex_category::getRootCategories($this->ignoreOffline,1);
      if (!empty($categories)) {
         if (!empty($categories)) {
            $out .= '<ul class="lev-0 nav_block'.$cssclass.'">';
            foreach ($categories as $key => $category) {
               if ($this->metaField) {
                  if (!$this->filterNav($category)) continue;
               } 
               $out .= $this->_getCategory($category);
            }
            $out .= '</ul>';
            return $out;
         }
      }
   }
   
   private function filterNav($category) {
      return ($category->getValue($this->metaField) == $this->metaValue);
   }

   private function _getCategory($cat,$lev) {
      $lev++;
      $out = '';
      $class = 'inactive';
      $cssclass = (isset($this->ulClasses[$lev])) ? ' '.$this->ulClasses[$lev] : '';
      
      if ($cat->getId() == $this->currentCatId) {
         $class = 'current';
      } elseif (in_array($cat->getId(), $this->currentPath)) {
         $class = 'active';
      }
      $out .= '
          <li class="'.$class.'">
            <a href="' . $cat->getUrl() . '">' . $cat->getName() .'</a>';
      if ( !empty($_categories = $cat->getChildren($this->ignoreOffline)) 
            && ($this->fullTree || in_array($cat->getId(), $this->currentPath))
            && $lev < $this->maxLev
            ) {
         $out .= '<ul class="lev-'.$lev.$cssclass.'">';
         foreach ($_categories as $_cat) {
            $out .= $this->_getCategory($_cat,$lev);
         }
         $out .= '</ul>';
      }
      $out .= '</li>';
      return $out;
   }

}
